C++ Concurrency In Action 
=========================
*Practical Multithreading*
-------------------------
- 作者：Anthony Williams
- 译者：陈晓伟

## 本书概述

作为对《C++ Concurrency in Action》的中文翻译。

本书是基于C++11新标准的并发和多线程编程深度指南。

从std::thread、std::mutex、std::future和std::async等基础类的使用，到内存模型和原子操作、基于锁和无锁数据结构的构建，再扩展到并行算法、线程管理，最后还介绍了多线程代码的测试工作。

本书的附录部分还对C++11新语言特性中与多线程相关的项目进行了简要的介绍，并提供了C++11线程库的完整参考。

本书适合于需要深入了解C++多线程开发的读者，以及使用C++进行各类软件开发的开发人员、测试人员。

对于使用第三方线程库的读者，也可以从本书后面的章节中了解到相关的指引和技巧。

同时，本书还可以作为C++11线程库的参考工具书。

## 书与作者

Anthony Williams是BSI C++小组的成员，拥有10多年C++应用经验。

如今多核芯处理器使用的越来越普遍。C++11标准支持多线程，这就需要程序员掌握多线程编程的原则、技术和新语言中的并发特性，确保自己处于时代前沿。

无论你的C++技术如何，本书都会指引你使用C++11写出健壮和优雅的多线程应用。本书将会探讨线程的内存模型，新的多线程库，启动线程和同步工具。在这个过程中，我们会了解并发程序中较为棘手的一些问题。

内容的大体结构：

- C++11编程
 
- 多核芯编程

- 简单例子用于学习，复杂例子用于实践

本书是为C++程序员所写，同僚中可能有人对并发还没什么了解，估计也有人已经使用其他语言、API或平台写过多线程程序。不过，在看本书的时候，你们都在同一“起跑线”上。

访问本书论坛[曼宁-C++ Concurrency in Action](http://www.manning.com/williams/)可获取免费试读章节电子书。

## 本书相关

- github 翻译地址：https://github.com/xiaoweiChen/Cpp_Concurrency_In_Action
- gitbook 在线阅读：http://chenxiaowei.gitbooks.io/cpp_concurrency_in_action/
- 书中源码：https://github.com/bsmr-c-cpp/Cpp-Concurrency-in-Action
- 学习C++11/14: http://www.bogotobogo.com/cplusplus/C11
